// Vraceni objektu hodnotou

#include <iostream>
#include <string>
#include <list>
using namespace std;

class GO;
typedef list<GO*> SGO;

enum Barva{CERNA, BILA, ZELENA};
string jmena[] = {"cerna","bila", "zelena"};

SGO sgo;

class GO                              // Spolecna bazova trida
{                                     // Tentokrat neni abstraktni
protected:
   int barva;
public:
   GO(int _barva = BILA): barva(_barva){}
   virtual ~GO(){}
   virtual void Nakresli(int _barva) const;
   void Zobraz() const { Nakresli(barva); }
   void Smaz() const { Nakresli(CERNA); }
   int jakaBarva() { return barva; }
};

void GO::Nakresli(int _barva) const
{
	cout << "kreslim GO, barva " << jmena[_barva] << endl;
}

class bod: public GO                  // Jeden z potomku
{
private:
   int x, y;
public: 
	bod(int _x, int _y, int _barva): x(_x), y(_y), GO(_barva) {}
   virtual ~bod(){}
   virtual void Nakresli(int _barva) const;
};

class Chyba: public GO{
public:
	Chyba(){}
};

void bod::Nakresli(int _barva) const
{
	cout << "kreslim bod, barva " << jmena[_barva] << endl;
	cout << "(" << x << ", " << y << ")";
}



void cekej()
{
	// implementace neni podstatna
}

void Blikej(GO g, int kolikrat)        // Spatne
{
   for(int i = 0; i < kolikrat; i++)
   {
      cekej();                         // Funkce cekej() pocka
      g.Smaz();                        // nejaky cas, aby blikani
      cekej();                         // bylo videt
      g.Zobraz();
   }
}

GO Prvni(Barva b)                      // Nefunguje
{
   for(list<GO*>::iterator igo = sgo.begin();
       igo != sgo.end();
       igo++) 
      if ((*igo)->jakaBarva() == ZELENA)
         return **igo;                 // Nasel - vrati objekt
   return Chyba();                       // Nenasel - indikuje chybu
}


int main()
{
	bod b(5,5,BILA);
	b.Zobraz();
	Blikej(b, 5);

	sgo.push_back(new bod(2,5, ZELENA));
	Prvni(ZELENA).Zobraz();
	delete sgo.back();
}
