// Co kdyz dostaneme pravouhly trojuhelnik?
// je treba pouzit atan2.

#include <cmath>
using namespace std;

const double PI = 3.14159265358979323;

inline double sqr(double x){ return x*x; }  // Druha mocnina

class bod                                   // Bod v rovine
{
   double x, y;
public :
   bod(double _x, double _y):x(_x), y(_y){}
   friend double delka(bod& M, bod& N);     // Delka strany MN
};

inline double delka(bod& M, bod& N)
{
   return sqrt(sqr(M.x-N.x)+sqr(M.y-N.y));
}
// Vypocet uhlu sevreneho stranami a, b

inline double uhel(double plocha, double a, double b, double c)
{ 
   return atan(4*plocha / (sqr(a) + sqr(b) - sqr(c)));
}

/* Spravna verze
inline double uhel(double plocha, double a, double b, double c)
{ 
   return atan2(4*plocha, (sqr(a) + sqr(b) - sqr(c)));
}
*/

inline double stupne(double s)         // Prevod z obloukove
{                                      // miry na stupne
   return s/PI*180;
}

int main()
{
   double a, b, c, s, S, alfa, beta, gama;
   bod A(5.9, 4.5), B(-9.87, 11.87), C(0, 1.56);
   a = delka(B, C);            // Delky stran
   b = delka(A, C);   
   c = delka(A, B);
   s = (a+b+c)/2;                      // Polovicni obvod
   S = sqrt((s - a)*(s-b)*(s-c)*s);    // Plocha
   alfa = stupne(uhel(S, b, c, a));    // Uhly ve stupnich
   beta = stupne(uhel(S, c, a, b));
   gama = stupne(uhel(S, b, a, c));
   // ... a dalsi zpracovani
   return 0;
}
