#include <iostream>
using namespace std;
// barvy pro kresleni grafickych objektu a jejich nazvy
enum Barva {cerna, bila, zelena, modra, cervena};
char *BARVA[] = {"cerna", "bila", "zelena", "modra", "cervena"};
class GO								// Spolecny predek vsech grafickych objektu
{
protected:
   int barva;
   static int pocet;
public:
   GO(int barva): barva(barva) {pocet++;}
   void Zobraz() const;
   void Smaz() const;
   virtual void Nakresli(int _barva=zelena) const;
   virtual ~GO(){
	   pocet--;
   }
};

int GO::pocet = 0;
void GO::Zobraz() const
{
   Nakresli(barva);
}
void GO::Smaz() const
{
   Nakresli(cerna);
}
void GO::Nakresli(int _barva) const
{
   cout << "GO, barva " << BARVA[_barva] << endl;
}
class bod: public GO
{
protected:
   int x, y;
   static int pocet;
public:
   bod(int x, int y, int barva): GO(barva), x(x), y(y) {pocet++;}
   void Nakresli(int _barva=bila) const;
   ~bod(){pocet--;}
};
int bod::pocet = 0;

void bod::Nakresli(int _barva) const
{
   cout	<< "bod, barva " << BARVA[_barva] << ", souradnice " 
   << x << ", " << y << endl;
}
class usecka: public GO { 
bod A, B;
public:
   usecka(int x1, int y1, int x2, int y2, int barva)
   : GO(barva), A(x1, y1, barva), B(x2, y2, barva)
   {}
   void Nakresli(int _barva) const;
};

void usecka::Nakresli(int _barva)const 
{
   cout << "usecka, barva " << BARVA[_barva] << ", pocatek a konec: "; 
   A.Nakresli(_barva);
   B.Nakresli(_barva);
}

int main()
{
  	const int N = 10;
	GO *go[N];
  	// ...
  	for(int i = 0; i < N; i++) 
  		go[i] = new bod(10*i, 10*i, bila);
  	for(int i = 0; i < N; i++) go[i]->Zobraz();
  	// ..
  	for(int i = 0; i < N; i++) delete go[i];
  	return 0;
}