// Nezaporny zlomek
// zjednodusena verze prikladu z knihu

#include <iostream>
#include <limits>
#include <stdexcept>
#include <algorithm>
using namespace std;

class zlomek { 
   unsigned citatel, jmenovatel, cela_cast; // Soucasti zlomku 
            // Pomocne funkce:
   static unsigned abs(int); // Absolutni hodnota celeho cisla
   void kraceni();           // Nejvetsi spol. delitel 
  
public: 
   static unsigned nsd(unsigned a, unsigned b);   // a kraceni zlomku
   zlomek(unsigned _citatel=0, unsigned _jmenovatel=1);
   friend ostream& operator<<(ostream& o, const zlomek& z);
   zlomek& operator +=(const zlomek& z);
   zlomek operator+(const zlomek& z) const;
   const zlomek& operator++();         // Prefixovy operator
   const zlomek operator++(int);       // Postfixovy operator (?)
};

zlomek::zlomek(unsigned _citatel, unsigned _jmenovatel)
:citatel(_citatel), jmenovatel(_jmenovatel), cela_cast(0)
{
	kraceni();
}

unsigned zlomek::abs(int i)
{    // Absolutni hodnota, ktera zvladne i okrajove pripady
   if(i == numeric_limits<int>::min()) 
      return (unsigned)numeric_limits<int>::max()+1;
   else 
   return i>0 ? i : -i;
}
const zlomek& zlomek::operator++()
{
   return *this += 1;
}
const zlomek zlomek::operator++(int)   // ??
{
   return *this += 1;
}

void zlomek::kraceni()
{
	if(cela_cast)citatel += jmenovatel*cela_cast;
	cela_cast = citatel/jmenovatel;
	if(cela_cast)citatel -= cela_cast*jmenovatel;
	int n = nsd(jmenovatel, citatel);
	citatel /= n;
	jmenovatel /= n;
}

zlomek& zlomek::operator +=(const zlomek& z)
{
	cela_cast += z.cela_cast;
	citatel = citatel*z.jmenovatel + jmenovatel*z.citatel;
	jmenovatel *= z.jmenovatel;
	kraceni();
	return *this;
}

/* spravna verze */
/*
const zlomek zlomek::operator++(int)
{
   zlomek z(*this);          // Vytvorime kopii operandu
   *this += 1;               // Inkrementujeme operand
   return z;                 // Vratime kopii puvodniho operandu
}
*/

unsigned zlomek::nsd(unsigned a, unsigned b)
{
	if(b)
	   return nsd(b, a%b);
	else return a;
}

ostream& operator<<(ostream& Ost, const zlomek& z)
{
	return Ost << z.cela_cast*z.jmenovatel+z.citatel << "/" << z.jmenovatel;
}

int main()
{
  zlomek z1(30,4); 
  zlomek z2(1, 2); 	
  // z1 += z2;
  cout << z1 << endl;
  cout << z1++ << endl;
}