// S doplnenymi kopirovacimi metodami

#include <deque>
#include <iostream>
#include <algorithm>
#include <iterator>
using namespace std;

template<typename T, typename Kontejner = deque<T> >
class Stack
{
public:
	typedef typename Kontejner::iterator iterator;
	
	Stack(){kont = new Kontejner;}
	Stack(const Stack& s);
	template<typename U, typename KontejnerU>
		Stack(Stack<U, KontejnerU>& s);
	~Stack(){delete kont;}

	void push(T co) {kont->push_back(co);}
	T top(){return kont->back();}
	void pop(){kont->pop_back();}
	iterator begin() {return kont->begin();}
	iterator end() {return kont->end();}
	Stack& operator=(Stack<T, Kontejner>& s);
	template<typename U, typename KontejnerU>
		Stack& operator=(Stack<U, KontejnerU>& s);

	// a dalsi deklarace...
private:
	Kontejner *kont;
};

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
Stack<T, KontejnerT>::Stack(Stack<U, KontejnerU>& s)
{
	kont = new KontejnerT;
	copy(s.begin(), s.end(), back_inserter(*kont));
}

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
Stack<T, KontejnerT>& Stack<T, KontejnerT>::operator=(Stack<U, KontejnerU>& s)
{
	kont->clear();
	copy(s.begin(), s.end(), back_inserter(*kont));
	return *this;
}

template<typename T, typename Kontejner>
Stack<T, Kontejner>& Stack<T, Kontejner>::operator=(Stack<T, Kontejner>& s)
{
	kont->clear();
	copy(s.begin(), s.end(), back_inserter(*kont));
	return *this;
}

template<typename T, typename Kontejner>
Stack<T, Kontejner>::Stack(Stack<T, Kontejner> const& s)
{
	kont = new KontejnerT;
	copy(s.begin(), s.end(), back_inserter(*kont));
}

int main()
{
	Stack<char> s;
	s.push('A');
	s.push('B');
	Stack<char> sc(s);
    	for(Stack<char>::iterator i = s.begin(); i != s.end(); i++)
		cout << *i << endl;
	Stack<double> sd(s);
	for(Stack<double>::iterator i = sd.begin(); i != sd.end(); i++)
		cout << *i << endl;
	Stack<int> si, sj;
	si = s;
	sj = si;
	for(Stack<double>::iterator i = sd.begin(); i != sd.end(); i++)
		cout << *i << endl;
}