#include <iostream>
#include <deque>
using namespace std;

// barvy pro kresleni grafickych objektu a jejich nazvy
enum Barva {cerna, bila, zelena, modra, cervena};
char *BARVA[] = {"cerna", "bila", "zelena", "modra", "cervena"};

class GO								// Spolecny predek vsech grafickych objektu
{
protected:
   int barva;
public:
   GO(int barva): barva(barva) {}
   void Zobraz() const;
   void Smaz() const;
   virtual void Nakresli(int _barva) const = 0;
   virtual ~GO(){}
};

void GO::Zobraz() const
{
   Nakresli(barva);
}
void GO::Smaz() const
{
   Nakresli(cerna);
}
/*
void GO::Nakresli(int _barva) const
{
   cout << "GO, barva " << BARVA[_barva] << endl;
}
*/
class bod: public GO
{
protected:
   int x, y;
public:
   bod(int x, int y, int barva): GO(barva), x(x), y(y) {}
   void Nakresli(int _barva) const;
   ~bod(){cout << "d" << endl;}
};

void bod::Nakresli(int _barva) const
{
   cout	<< "bod, barva " << BARVA[_barva] << ", souradnice " 
   << x << ", " << y << endl;
}
class usecka: public GO { 
bod A, B;
public:
   usecka(int x1, int y1, int x2, int y2, int barva)
   : GO(barva), A(x1, y1, barva), B(x2, y2, barva)
   {}
   void Nakresli(int _barva) const;
};

void usecka::Nakresli(int _barva)const 
{
   cout << "usecka, barva " << BARVA[_barva] << ", pocatek a konec: "; 
   A.Nakresli(_barva);
   B.Nakresli(_barva);
}

class obrazek: public GO
{
	deque<GO*> obrazky;
public:
	obrazek():GO(0){}
	void Pridej(GO* g);
	void Nakresli(int _barva) const;
	void Vyprazdni();
};

void obrazek::Vyprazdni()
{
	for(int i = 0; i < obrazky.size(); i++)
		delete obrazky[i];
}

void obrazek::Pridej(GO* g)
{
	obrazky.push_back(g);
}
 
void obrazek::Nakresli(int barva) const
{
	deque<GO*>::const_iterator i = obrazky.begin();
	while(i != obrazky.end())
	{
		(*i++)->Nakresli(barva);
	}
}

void NakresliCmaranici()
{
	obrazek Obr;
	Obr.Pridej(new bod(11,20,3));
	Obr.Pridej(new usecka(1,2,5,4,1));
	Obr.Zobraz();
	Obr.Vyprazdni();
}

int main()
{
	NakresliCmaranici();
	obrazek A;
	A.Pridej(new bod(1,2,3));
	A.Zobraz();
}