// Oprava chybne hierarchie -- "technicka dedicnost"

#include <iostream>
#include <string>
using namespace std;

class GO			// Graficky objekt
{
public:
	enum barvy{cerna, bila};
	static string nazvy[];
	// abstraktni metody
	virtual void nakresli(int barva) = 0;
	virtual void posun(int dx, int dy)=0;
	// nevirtualni metody (potomci je neprekryvaji)
	void zobraz(){nakresli(bila);}
	void smaz(){nakresli(cerna);}
};

string GO::nazvy[]={"cerna", "bila"};

class Bod: public GO
{
protected:
	int x, y;
public:
	Bod(int xx, int yy):x(xx), y(yy){}
	virtual void nakresli(int barva);
	virtual void posun(int dx, int dy);
	void zmenSouradnice(int dx, int dy){x += dx; y += dy;}
};

void Bod::posun(int dx, int dy)
{
	smaz();
	zmenSouradnice(dx, dy);
	zobraz();
}


void Bod::nakresli(int barva)
{
	cout << "Kreslim Bod, barva: " << nazvy[barva]
	     << " (" << x << ", " << y << ")" << endl; 
}

class Kruznice: public GO
{
	int r;
	Bod stred;
public:
	Kruznice(int xx, int yy, int rr): stred(xx, yy), r(rr){}
	virtual void nakresli(int barva);
	virtual void posun(int dx, int dy);
};

void Kruznice::posun(int dx, int dy)
{
	smaz();
	stred.zmenSouradnice(dx, dy);
	zobraz();
}

void Kruznice::nakresli(int barva)
{
	cout << "Kreslim Kruznici, barva: " << nazvy[barva] << ", stred: ";
	stred.nakresli(barva);
	cout << ", polomer: " << r << endl;
}

class Usecka: public GO
{					// Zdedeny podobjekt je pocatkem usecky
	Bod pocatek, konec;
public:
	Usecka(int x1, int y1, int x2, int y2)
		: pocatek(x1, y1), konec(x2, y2){}
	Usecka(Bod& A, Bod& B)
		: pocatek(A), konec(B){}
	virtual void nakresli(int barva);
	virtual void posun(int dx, int dy);
};


void Usecka::nakresli(int barva)
{
	cout << "Kreslim Usecku, barva: " << nazvy[barva] << ", pocatek a konec: " << endl;
	pocatek.nakresli(barva);
	konec.nakresli(barva);
}

void Usecka::posun(int dx, int dy)
{
	smaz();
	pocatek.zmenSouradnice(dx, dy);
	konec.zmenSouradnice(dx, dy);
	zobraz();
}


int main()
{
	Kruznice K(3,4,5);
	K.zobraz();
	K.posun(1,1);
	Usecka U(1,2,3,4);
	U.zobraz();
	U.posun(4,6);
}