// Chybna hierarchie -- "Technicke dedeni"

#include <iostream>
#include <string>
using namespace std;


class Bod: public GO
{
protected:
	int x, y;
	static string nazvy[];
public:
	void zobraz(){nakresli(bila);}
	void smaz(){nakresli(cerna);}
	enum barvy{cerna, bila};
	Bod(int xx, int yy):x(xx), y(yy){}
	virtual void nakresli(int barva);
	virtual void posun(int dx, int dy);
	void zmenSouradnice(int dx, int dy){x += dx; y += dy;}
};

string Bod::nazvy[]={"cerna", "bila"};

void Bod::posun(int dx, int dy)
{
	smaz();
	zmenSouradnice(dx, dy);
	zobraz();
}


void Bod::nakresli(int barva)
{
	cout << "Kreslim Bod, barva: " << nazvy[barva]
	     << " (" << x << ", " << y << ")" << endl; 
}

class Kruznice: public Bod
{
	int r;
public:
	Kruznice(int xx, int yy, int rr): Bod(xx, yy), r(rr){}
	virtual void nakresli(int barva);
	virtual void posun(int dx, int dy);
};

void Kruznice::posun(int dx, int dy)
{
	smaz();
	zmenSouradnice(dx, dy);
	zobraz();
}

void Kruznice::nakresli(int barva)
{
	cout << "Kreslim Kruznici, barva: " << nazvy[barva] << ", stred: ";
	Bod::nakresli(barva);
	cout << ", polomer: " << r << endl;
}

class Usecka: public Bod // Usecka urcena dvema body
{					// Zdedeny podobjekt je pocatkem usecky
	Bod konec;
public:
	Usecka(int x1, int y1, int x2, int y2)
		: Bod(x1, y1), konec(x2, y2){}
	Usecka(Bod& A, Bod& B)
		: Bod(A), konec(B){}
	virtual void nakresli(int barva);
	virtual void posun(int dx, int dy);
};


void Usecka::nakresli(int barva)
{
	cout << "Kreslim Usecku, barva: " << nazvy[barva] << ", pocatek a konec: " << endl;
	Bod::nakresli(barva);
	konec.nakresli(barva);
}

void Usecka::posun(int dx, int dy)
{
	smaz();
	Bod::zmenSouradnice(dx, dy);
	konec.zmenSouradnice(dx, dy);
	zobraz();
}


int main()
{
	Kruznice K(3,4,5);
	K.zobraz();
	K.posun(1,1);
	Usecka U(1,2,3,4);
	U.zobraz();
	U.posun(4,6);
}