// Definice a pouziti vlastni fazety
// pro formatovani cisel a logickych hodnot

#include <iostream>
#include <stdexcept>
#include <fstream>
#include <locale>
#include <algorithm>

using namespace std;

enum obdobi {jaro, leto, podzim, zima};

class Obd_vv: public locale::facet {      // Abstraktn pedek
public:
   Obd_vv(int i = 0): locale::facet(i){}
   ~Obd_vv(){}
   virtual const string& to_str(obdobi x) const = 0;//{static const string s("");return s;};
   virtual bool from_str(const string& s, obdobi& x) const = 0; //{return true;}
   static locale::id id;
};

locale::id Obd_vv::id;

class CZ_Obd_vv: public Obd_vv      // Implementace pro esk
{                     // nastaven
   static const string nazvy[];
public:
   const string& to_str(obdobi) const;
   bool from_str(const string&, obdobi&) const;
   //CZ_Obd_vv(int i = 0): Obd_vv(i){}
};

const string CZ_Obd_vv::nazvy[] = {"jaro","lto","podzim","zima"};

// Implementace metod pro pevod na etzec a z nj
const string& CZ_Obd_vv::to_str(obdobi x) const
{
   static const string s("nesprvn obdob");
   if(x < jaro || x > zima) return s;
   else return nazvy[x];
}

bool CZ_Obd_vv::from_str(const string& s, obdobi& x) const
{
 const string* p = find<const string*, string>(nazvy, &nazvy[zima+1], s);
 if(p == &nazvy[zima+1]) return false;
 x = obdobi(p - nazvy);
 return true;
}

// Peten opertory pro vstup a vstup,
// kter vyuvaj slueb fazety Obd_vv
ostream& operator<<(ostream& Proud, obdobi x)
{
   const locale& loc = Proud.getloc();
   if(has_facet<Obd_vv>(loc)) 
return Proud << use_facet<Obd_vv>(loc).to_str(x);
   else 
return Proud << int(x);
};

istream& operator>>(istream& Proud, obdobi &x)
{
const locale &loc = Proud.getloc();
if(has_facet<Obd_vv>(loc)){
const Obd_vv& f = use_facet<Obd_vv>(loc);
string buf;
if(!(Proud >> buf && f.from_str(buf, x))) 
Proud.setstate(ios_base::failbit);
return Proud;
}
int i;
Proud >> i;
x = obdobi(i);
return Proud;
}

int main()
{
   try{
      locale Cr("Czech_Czech Republic.852");
      locale Kon(Cr, new CZ_Obd_vv);
      obdobi ob = leto;
      cout.imbue(Kon);
           cin.imbue(Kon);
      cout << ob << endl;
        cin >> ob;
cout << int(ob) << endl;
   }
   catch(runtime_error &e)
   {
      cerr << e.what() << endl;
   }
   return 0;
}
