// Definice a pouziti vlastni fazety 
// pro formatovani cisel a logickych hodnot

#include <iostream> 
#include <stdexcept>
#include <fstream>
#include <locale>

using namespace std;

class punkt_w: public std::numpunct<wchar_t> {
public:
   typedef wchar_t char_type;
   typedef wstring string_type;
   explicit punkt_w(size_t r = 0): std::numpunct<wchar_t>(r){}
protected:
   char_type do_decimal_point() const {return ',';}
   char_type do_thousands_sep() const {return ' ';}
   string do_grouping() const {return "\003";}
   string_type do_truename() const {return L"pravda";};
   string_type do_falsename() const {return L"nepravda";};
};

wchar_t cw[] = L"luouk k pern pl belsk dy.";

int main()
{
   try{
      locale Cr("Czech_Czech Republic.852");
      locale Kon(Cr, new punkt_w(0));
      wcout.imbue(Kon);
      wcin.imbue(Kon);
      wcout << cw << endl;

      bool b = true;
      int n = 12345;
      double d = 12.345678;
      wcin >> boolalpha;
      wcout << boolalpha << b << endl;
      wcout << n << endl;
      wcout << d << endl;
      wcout << L"zadej reln slo: ";
      wcin >> d;
      wcout << L"dvojnsobek je "<< d*2 << endl;
      wcout << L"zadej cel slo: ";
      wcin >> n;
      wcout << L"dvojnsobek je "<< 2*n << endl;
      wcout << L"zadej logickou hodnotu: ";
      wcin >> b;
      wcout << L"Opak je " << !b << endl;
   }
   catch(runtime_error &e)
   {
      cerr << e.what() << endl;
   }
   return 0;
}
